#include <stdio.h>
#include <stdlib.h>

#include <mpi.h>

int main (int argc, char ** argv)
{
  int size, rank, rlen, N;
  char myname[MPI_MAX_PROCESSOR_NAME]; 

  MPI_Init (&argc, &argv);

  MPI_Comm_size (MPI_COMM_WORLD, &size);
  
  MPI_Comm_rank (MPI_COMM_WORLD, &rank);

  MPI_Get_processor_name (myname, &rlen);

  if (argc == 2)
    N = atoi (argv[1]);
  else 
    N = 10;

  fprintf (stdout, "I am proces %3d of %3d my name is %s (%s)\n", 
    rank, size, myname, argv[0]);

  if (size == 2) {
    if (rank == 0) {
      float * vec;
      int i;

      if ( (vec = malloc (sizeof(float)*N)) == NULL) { 
        fprintf (stderr, "Memory allocation error");
        return 1;
      }
      for (i=0; i<N; i++)
        vec[i] = 1.0 + (float) ((float) N * (rand() / (RAND_MAX + 1.0)));

      MPI_Send (vec, N, MPI_FLOAT, 1, 1, MPI_COMM_WORLD);
    }
    else {
      float * vec;
      if ( (vec = malloc (sizeof(float)*N)) == NULL) {
        fprintf (stderr, "Memory allocation error");
        return 1;
      }

      MPI_Status status;
      MPI_Recv (vec, N, MPI_FLOAT, 0, 1, MPI_COMM_WORLD, &status);
      fprintf (stdout, "I am %s and I recv vec\n", myname);
    }
  }
  
  MPI_Finalize ();
 
  return 0;
} 
