#include <stdio.h>
#include <stdlib.h>

#include <mpi.h>

int main (int argc, char ** argv)
{
  char myname[MPI_MAX_PROCESSOR_NAME]; 
  int size, rank, rlen, N;
  MPI_Status status;

  MPI_Init (&argc, &argv);

  MPI_Comm_size (MPI_COMM_WORLD, &size);
  
  MPI_Comm_rank (MPI_COMM_WORLD, &rank);

  MPI_Get_processor_name (myname, &rlen);

  if (rank == 0) {
    if (argc == 2) {
      N = atoi (argv[1]);
      if (N < 0)
        N = 10;
    }
    else 
      N = 10;
  }

  fprintf (stdout, "I am proces %3d of %3d my name is %s (%s)\n", 
    rank, size, myname, argv[0]);

  fflush(stdout);

  if (size > 1) {
    if (rank == 0) {
      int val = N;
    
      do {
        fprintf (stdout, "  Ring value %d\n", val);
        MPI_Send (&val, 1, MPI_INT, 1, 1, MPI_COMM_WORLD);
        MPI_Recv (&val, 1, MPI_INT, size-1, 1, MPI_COMM_WORLD, &status);
        val--;
      } while (val >= 0);
    
      fprintf (stdout, "Ring stop %d\n", val);
    }
    else {
      int val;
    
      do {
        MPI_Recv (&val, 1, MPI_INT, rank-1, 1, MPI_COMM_WORLD, &status);
        if (rank == (size-1))
          MPI_Send (&val, 1, MPI_INT, 0, 1, MPI_COMM_WORLD);
        else
          MPI_Send (&val, 1, MPI_INT, rank+1, 1, MPI_COMM_WORLD);
      } while (val > 0);
    }
  }

  MPI_Finalize ();
 
  return 0;
} 
