#include <stdio.h>
#include <stdlib.h>

#include <mpi.h>

int main (int argc, char ** argv)
{
  char myname[MPI_MAX_PROCESSOR_NAME]; 
  int size, rank, rlen, N, from, next;
  MPI_Status status;

  MPI_Init (&argc, &argv);

  MPI_Comm_size (MPI_COMM_WORLD, &size);
  
  MPI_Comm_rank (MPI_COMM_WORLD, &rank);

  MPI_Get_processor_name (myname, &rlen);

  fprintf (stdout, "I am proces %3d of %3d my name is %s (%s)\n", 
    rank, size, myname, argv[0]);

  fflush(stdout);

  if (size > 1) {
    int val;

    next = (rank + 1) % size;
    from = (rank + size - 1) % size;

    if (rank == 0) {
      if (argc == 2) {
        N = atoi (argv[1]);
        if (N < 0)
          N = 10;
      }
      else 
        N = 10;
    
      MPI_Send (&N, 1, MPI_INT, next, 1, MPI_COMM_WORLD);
    }
    
    do {
      MPI_Recv (&val, 1, MPI_INT, from, 1, MPI_COMM_WORLD, &status);
      
      if (rank == 0) {
        val--;
        fprintf (stdout, "  Ring value %d\n", val);
        fflush (stdout);
      }

      MPI_Send (&val, 1, MPI_INT, next, 1, MPI_COMM_WORLD);
    } while (val > 0);

    if (rank == 0) 
      MPI_Recv (&val, 1, MPI_INT, from, 1, MPI_COMM_WORLD, &status);
  }

  MPI_Finalize ();
 
  return 0;
} 
